// exercices 1 et 2

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

#include "ensemble.h"

/* lire une ligne dans un fichier texte
 */
int chaine_lire(ENSEMBLE *ensemble, FILE *f)
{
	char *ligne;
	int c;
	
	assert(ensemble != NULL);
	assert(f != NULL);

	// sauter les espaces
	c= fgetc(f);
	while(c!=EOF && (c==' ' || c=='\t' || c=='\r' || c=='\n'))
		c= fgetc(f);

	// ne pas lire les separateurs et la ponctuation
	while(c!=EOF && c!='\'' && c!=',' && c!='.' && c!=':' && c!=';' && c!='?' && c!='!' && c!='(' && c!=')' && c!='\r' && c!='\n')
	{
		ensemble_verifier((void **) &ensemble->data, &ensemble->size, ensemble->n, sizeof(char), 100);
		ligne= (char *) ensemble->data;

		ligne[ensemble->n]= c;
		ensemble->n= ensemble->n +1;

		c= fgetc(f);
	}
	
	// ajouter le 0 pour terminer la chaine
	ensemble_verifier((void **) &ensemble->data, &ensemble->size, ensemble->n, sizeof(char), 1);
	ligne= (char *) ensemble->data;
	ligne[ensemble->n]= 0;
	ensemble->n= ensemble->n +1;

	if(c==EOF)
		return -1;
	else
		return ensemble->n;
}


/* c'est dans le titre
 */
void chaine_afficher(ENSEMBLE *ensemble)
{
	char *ligne;
	int i;
	
	assert(ensemble != NULL);
	
	ligne= (char *) ensemble->data;
	for(i= 0; i < ensemble->n; i++)
		printf("%c", ligne[i]);
}


/* ajouter une chaine de caracteres (parametre sous_chaine) a l'ensemble de caracteres (parametre ensemble)
 */
void chaine_inserer_sous_chaine(ENSEMBLE *ensemble, char *sous_chaine, int debut, int fin)
{
	char *ligne;
	int i;
	
	assert(ensemble != NULL);

	for(i= debut; i < fin; i++)
	{
		ensemble_verifier((void **) &ensemble->data, &ensemble->size, ensemble->n, sizeof(char), 10);
		ligne= (char *) ensemble->data;

		ligne[ensemble->n]= sous_chaine[i];
		ensemble->n= ensemble->n +1;
	}

	// ajouter le 0 pour terminer la chaine
	ensemble_verifier((void **) &ensemble->data, &ensemble->size, ensemble->n, sizeof(char), 1);
	ligne= (char *) ensemble->data;
	ligne[ensemble->n]= 0;
	ensemble->n= ensemble->n +1;
}
