// ensembles dynamiques

#include <stdlib.h>
#include <assert.h>

#include "ensemble.h"

/* creation d'un ensemble vide
 */
ENSEMBLE *ensemble_init(ENSEMBLE *ensemble)
{
	assert(ensemble != NULL);
	
	ensemble->data= NULL;
	ensemble->size= 0;
	ensemble->n= 0;
	
	return ensemble;
}

/* agrandi l'ensemble si necessaire

   entree: size = taille physique
   entree: n = rang a verifier / a rendre accessible
   entree: e_size, taille d'un element en octets obtenu avec sizeof()
   entree: e_more, nombre d'elements a ajouter a chaque allocation

   entree/sortie: parray, adresse du pointeur sur le tableau
 */
void ensemble_verifier(void **parray, int *size, int n, int e_size, int e_more)
{
	assert(parray != NULL);
	assert(size != NULL);

	if(n >= *size)
	{
		*size= ((n / e_more) + 1) * e_more;
		
		*parray= realloc(*parray, *size * e_size);
		assert(*parray!=NULL);
	}
}

/* elimine les elements stockes dans l'ensemble, mais ne detruit pas l'ensemble
*/
void ensemble_vider(ENSEMBLE *ensemble)
{
	assert(ensemble != NULL);
	
	ensemble->n= 0;
}

/* rend la memoire u systeme
 */
void ensemble_detruire(ENSEMBLE *ensemble)
{
	assert(ensemble != NULL);

	if(ensemble->data != NULL);
		free(ensemble->data);
}

